#include <ansi_c.h>
#include "MyFunctions.h"


//Function to solve quadratic equation
int CVIFUNC my_SolveQuadratic (double firstCoefficient, double secondCoefficient,
                                double thirdCoefficient, double *root1,
                                double *root2)
                               
{

int status=0;
double sqrtVal;
	if ( firstCoefficient==0) //first coefficient cannot be zero in quadratic equation
		return status =-1;
	//Check for negative square root 
	else if ( (secondCoefficient * secondCoefficient - 
	                              4 *firstCoefficient* thirdCoefficient ) < 0)
	    return status =-2;
	else  //Calculate the roots
		{
		sqrtVal= sqrt(secondCoefficient * secondCoefficient - 
	                                        4 *firstCoefficient* thirdCoefficient);
		 *root1 = (-secondCoefficient + sqrtVal) /(2 *firstCoefficient); 
		 *root2 = (-secondCoefficient - sqrtVal) /(2 *firstCoefficient); 
		 return status =0;
		}
	
} //my_SolveQuadratic
                                
                                
//Factorial calculations                                
int CVIFUNC my_Factor (unsigned int number, double *factorial)
{
   int status=0, i;
   double result;
   
   
	//Factorial of 0 is 1
	if (number == 0)
	{
		*factorial =1;
		return status=0;
	}
	//Number is too large 
	else if (number > 170 )
		return status=-1; 
	else 
	{  //Number is in valid range
		 result =1;
		 for ( i=1; i<=number; i++)
		 	result = result *i;
		 
		 *factorial=result;
		 return status =0;
    }
    
}//my_Factor


